# Dumps the content of a collection of shapefiles, dbf and shp.

if (($# != 1))
then
    echo "Required argument: directory containing collection of shapefiles"
    exit 1
fi

set -e

for shapefile in extremum outermost_contour max_speed_contour
do
    echo "------------------------------------------------"
    echo
    echo "dbfdump $1/$shapefile:"
    dbfdump $1/$shapefile
    echo
    echo "shpdump $1/$shapefile:"
    shpdump $1/$shapefile
done
